import { R as Request, b as Response, P as ParsedJSON } from '../index-eT2DDxGe.mjs';
import { Headers } from '../types.mjs';

interface ResponseFactoryArgs {
    method?: string;
    host?: string;
    path?: string;
    request?: Request;
    status?: number;
    data?: string | Record<string, unknown>;
    headers?: Headers;
    errors?: Array<Error | string>;
}
/**
 * Create a response to use in tests
 * @returns Response
 */
declare const responseFactory: ({ method, host, path, request, status, data, headers, errors, }?: ResponseFactoryArgs) => Response<ParsedJSON>;

export { type ResponseFactoryArgs, responseFactory };
